<template>
  <div class="summary-container">
    <div v-if="selectedRows.length" class="selected-rows-info">
      <span
        class="selected-rows-info__text"
        data-qa="deleteSelectedRows"
        @click="onDeleteSelectedRows"
      >
        <i class="icon delete selected-rows-info__delete-icon" />

        Убрать из списка победителей {{ selectedRows.length }} участников
      </span>
    </div>

    <div class="action-button">
      <ObButton
        label="Создать группу из финалистов тендера"
        :disabled="!winners.length"
        @click="addGroup"
      />
    </div>

    <ObTable
      ref="winnersTable"
      :items="tableItems"
      :columns="columns"
      :functional-panel="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      :tableLayoutFixed="true"
      data-qa="summaryTable"
      is-fixed-header
      @select="openParticipantQuestionnaire($event)"
    >

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template slot="checkbox" slot-scope="{ data }">
        <div @click.stop>
          <ObCheckbox
            v-model="data.item.checked"
            @change="toggleCheck(data.item)"
          />
        </div>
      </template>

      <template slot="date" slot-scope="{ data }">
        <div class="send-date">
          {{ formatDate(data.item.publishedDt) }}
          <span class="date-time">, {{ formatDate(data.item.publishedDt, true) }}</span>
        </div>
      </template>

      <template
        slot="edit-row"
        slot-scope="{ data }"
      >
        <ObMenuDropdown :items="getDropdownItems(data.item)" />
      </template>
    </ObTable>

    <ObModal
      ref="confirmDeleteRows"
      title="Удаление контрагентов"
      size="sm"
      :is-show-pagination="false"
      :is-show-controls="true"
      ok-text="Удалить"
      cancel-text="Отменить"
      data-qa="confirmDeleteRowsModal"
      @submit="deleteMultipleWinners"
    >
      Вы точно хотите {{ selectedRows.length }} контрагентов?
    </ObModal>

    <ObModal
      ref="participant-questionnaire"
      size="extra-large"
      :title="questionnaireTitle"
      :is-show-close-button="true"
    >
      <ParticipantQuestionnaire
        :key="participantUuid"
        :questionnaire-uuid="tender.questionnaireUuid"
        :participant-uuid="participantUuid"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />

    <ObModal
      ref="addGroupModal"
      title="Группа"
      title-second="Добавление"
      size="medium"
      :is-show-controls="false"
    >
      <CreateParticipantGroup
        :title="tender.title"
        :is-dirty-force="true"
        @submit="onGroupAdded"
      />
    </ObModal>
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ParticipantQuestionnaire from '../offers/modal/participantQuestionnaire'
  import api from '@/api'
  import { mapGetters, mapActions } from 'vuex'
  import ExportExcel from '../../mixins/export-excel'
  import CreateParticipantGroup from '../../../../../../components/Tenders/createParticipantGroup'

  export default {
    name: 'tender-tab-buyer-summary-rfi',
    mixins: [
      ExportExcel
    ],
    components: {
      ObTable,
      ObCheckbox,
      ObMenuDropdown,
      ObModal,
      ObButton,
      ParticipantQuestionnaire,
      CreateParticipantGroup
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      ...mapGetters({
        winners: 'tenders/winners'
      }),
      columns () {
        return [
          {
            _isEnabled: this.isTenderStatusSummarizing,
            slotName: 'checkbox',
            width: 60,
            isToggleDisabled: true,
            sortDisable: true
          },
          {
            key: 'participantTitle',
            title: 'Название контрагента'
          },
          {
            key: 'participantInn',
            title: 'ИНН'
          },
          {
            key: 'countPoints',
            title: 'Всего баллов',
            isAlignRight: true
          },
          {
            key: 'publishedDt',
            title: 'Дата и время отправки анкеты, UTC+3',
            slotName: 'date'
          },
          {
            _isEnabled: this.isTenderStatusSummarizing,
            slotName: 'edit-row',
            width: 60,
            isToggleDisabled: true,
            sortDisable: true,
            action: true
          }
        ]
      },
      isTenderStatusSummarizing () {
        return this.tender.status === 'SUMMARIZING'
      },
      tableItems () {
        if (this.winners.length) {
          return this.winners
        } else {
          return []
        }
      }
    },
    data () {
      return {
        selectedRows: [],
        questionnaireTitle: null,
        participantUuid: null
      }
    },
    async mounted () {
      await this.fetchSummary()
    },
    methods: {
      ...mapActions({
        getWinners: 'tenders/getWinners'
      }),
      async fetchSummary () {
        await this.getWinners(this.tender.uuid)

        this.selectedRows = []
      },
      async openParticipantQuestionnaire (data) {
        this.participantUuid = data.participantUuid
        this.questionnaireTitle = `Анкета "${data.participantTitle}"`

        this.$refs['participant-questionnaire'].open()
      },
      toggleCheck (item) {
        if (item.checked) {
          this.selectedRows.push(item.participantUuid)
        } else {
          this.selectedRows = this.selectedRows.filter((uuid) => {
            return uuid !== item.participantUuid
          })
        }
      },
      getDropdownItems (item) {
        return [
          {
            title: 'Убрать из победителей',
            method: () => this.deleteWinner(item)
          }
        ]
      },
      onDeleteSelectedRows () {
        this.$refs.confirmDeleteRows.open()
      },
      async deleteWinner (item) {
        try {
          await api.tenders.deleteParticipantsFromTenderSummary(this.tender.uuid, {
            participants: [item.participantUuid]
          })

          this.$notification({
            type: 'snackbars',
            message: `"${item.participantTitle}" убран из списка победителей`
          })

          this.fetchSummary()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка удаления победителя'
          })
        }
      },
      async deleteMultipleWinners () {
        try {
          await api.tenders.deleteParticipantsFromTenderSummary(this.tender.uuid, {
            participants: this.selectedRows
          })

          this.$notification({
            type: 'snackbars',
            message: `${this.selectedRows.length} победителей убрано из списка`
          })

          this.fetchSummary()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка удаления победителей'
          })
        }

        this.$refs.confirmDeleteRows.close()
      },
      goToOffers () {
        this.$emit('changeTab', { id: 9 })
      },
      formatDate (date, onlyTime = false) {
        const parsedDate = new Date(date).toLocaleString('ru')

        return parsedDate.split(',')[onlyTime ? 1 : 0]
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFISummary(this.tender.uuid)
      },
      addGroup () {
        this.$refs.addGroupModal.open()
      },
      async onGroupAdded (uuid) {
        try {
          await api.tendersContractors.addParticipantsToGroup(uuid, {
            participants: this.winners.map(item => item.participantUuid)
          })

          this.$refs.addGroupModal.close()

          this.$notification({
            type: 'system_notification_success',
            message: 'Финалисты тендера успешно добавлены в группу'
          })
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка добавления финалистов тендера в группу'
          })
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .action-button {
    border-bottom: 1px solid $lavender;
    padding: 15px 20px;
  }

  .summary-container {
    height: 100%;
    min-height: 200px; // Чтобы пофиксить "улетающий" вверх 'noneContent'
  }

  .open-inn {
    margin-left: 32px;
    font-size: 24px;
    position: relative;
    top: 3px;
    cursor: pointer;
  }

  .date-time {
    color: $color-grey-span;
  }

  .selected-rows-info {
    padding-top: 20px;

    &__text {
      display: inline-block;
      vertical-align: middle;
      line-height: 28px;
      height: 28px;
      margin: 0 20px;
      color: $color-error;
      cursor: pointer;
    }

    &__delete-icon {
      font-size: 24px;
      display: inline-block;
      vertical-align: middle;
      margin-right: 5px;
    }
  }

  .send-date {
    display: flex;
  }
</style>
